# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Callable, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = [
    'GetUsersUserResult',
]

@pulumi.output_type
class GetUsersUserResult(dict):
    def __init__(__self__, *,
                 descriptor: str,
                 display_name: str,
                 id: str,
                 mail_address: str,
                 origin: str,
                 principal_name: str,
                 origin_id: Optional[str] = None):
        """
        :param str descriptor: The descriptor is the primary way to reference the graph subject while the system is running. This field will uniquely identify the same graph subject across both Accounts and Organizations.
        :param str display_name: This is the non-unique display name of the graph subject. To change this field, you must alter its value in the source provider.
        :param str id: The user ID.
        :param str mail_address: The email address of record for a given graph member. This may be different than the principal name.
        :param str origin: The type of source provider for the `origin_id` parameter (ex:AD, AAD, MSA) The supported origins are listed below.
        :param str principal_name: The PrincipalName of this graph member from the source provider.
        :param str origin_id: The unique identifier from the system of origin.
               
               DataSource without specifying any arguments will return all users inside an organization.
               
               List of possible subject types
               
               
               List of possible origins
        """
        GetUsersUserResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            descriptor=descriptor,
            display_name=display_name,
            id=id,
            mail_address=mail_address,
            origin=origin,
            principal_name=principal_name,
            origin_id=origin_id,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             descriptor: Optional[str] = None,
             display_name: Optional[str] = None,
             id: Optional[str] = None,
             mail_address: Optional[str] = None,
             origin: Optional[str] = None,
             principal_name: Optional[str] = None,
             origin_id: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if descriptor is None:
            raise TypeError("Missing 'descriptor' argument")
        if display_name is None and 'displayName' in kwargs:
            display_name = kwargs['displayName']
        if display_name is None:
            raise TypeError("Missing 'display_name' argument")
        if id is None:
            raise TypeError("Missing 'id' argument")
        if mail_address is None and 'mailAddress' in kwargs:
            mail_address = kwargs['mailAddress']
        if mail_address is None:
            raise TypeError("Missing 'mail_address' argument")
        if origin is None:
            raise TypeError("Missing 'origin' argument")
        if principal_name is None and 'principalName' in kwargs:
            principal_name = kwargs['principalName']
        if principal_name is None:
            raise TypeError("Missing 'principal_name' argument")
        if origin_id is None and 'originId' in kwargs:
            origin_id = kwargs['originId']

        _setter("descriptor", descriptor)
        _setter("display_name", display_name)
        _setter("id", id)
        _setter("mail_address", mail_address)
        _setter("origin", origin)
        _setter("principal_name", principal_name)
        if origin_id is not None:
            _setter("origin_id", origin_id)

    @property
    @pulumi.getter
    def descriptor(self) -> str:
        """
        The descriptor is the primary way to reference the graph subject while the system is running. This field will uniquely identify the same graph subject across both Accounts and Organizations.
        """
        return pulumi.get(self, "descriptor")

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> str:
        """
        This is the non-unique display name of the graph subject. To change this field, you must alter its value in the source provider.
        """
        return pulumi.get(self, "display_name")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The user ID.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="mailAddress")
    def mail_address(self) -> str:
        """
        The email address of record for a given graph member. This may be different than the principal name.
        """
        return pulumi.get(self, "mail_address")

    @property
    @pulumi.getter
    def origin(self) -> str:
        """
        The type of source provider for the `origin_id` parameter (ex:AD, AAD, MSA) The supported origins are listed below.
        """
        return pulumi.get(self, "origin")

    @property
    @pulumi.getter(name="principalName")
    def principal_name(self) -> str:
        """
        The PrincipalName of this graph member from the source provider.
        """
        return pulumi.get(self, "principal_name")

    @property
    @pulumi.getter(name="originId")
    def origin_id(self) -> Optional[str]:
        """
        The unique identifier from the system of origin.

        DataSource without specifying any arguments will return all users inside an organization.

        List of possible subject types


        List of possible origins
        """
        return pulumi.get(self, "origin_id")


